// DlgBitmapListe.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "DlgBitmapListe.h"
#include "DlgPleinEcran.h"
#include "resource.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgBitmapListe dialog
extern CMakeTerrainApp theApp;


CDlgBitmapListe::CDlgBitmapListe(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgBitmapListe::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgBitmapListe)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgBitmapListe::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgBitmapListe)
	DDX_Control(pDX, IDC_LISTE, Liste);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgBitmapListe, CDialog)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(CDlgBitmapListe)
	ON_WM_SIZE()
	ON_LBN_DBLCLK(IDC_LISTE, OnDblclkListe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgBitmapListe message handlers

void CDlgBitmapListe::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	CWnd * pWnd;
	pWnd = GetDlgItem (IDC_LISTE);
	if (pWnd)
		pWnd->MoveWindow (0,0,cx,cy,TRUE);
}

// Ajouter une image  la liste
void CDlgBitmapListe::AddBitmap (CString FileName)
{
	DWORD index;
	index = Liste.AddItem ("",0,0);
	Liste.SetBmpPath (index,FileName);
}




	

void CDlgBitmapListe::OnDblclkListe() 
{
	// TODO: Add your control notification handler code here
	DWORD index;
	CDlgPleinEcran Dlg;

	index = Liste.GetCurSel ();
	if (index == LB_ERR) return;

	HBITMAP hbmp;
	BITMAP bm;
	hbmp = Liste.GetFileName (index);
	if (hbmp == NULL) return;
	SIZE size;
	GetObject(hbmp,sizeof (BITMAP),&bm);

	size.cx = bm.bmWidth;
	size.cy = bm.bmHeight;
	Dlg.SetBitmapInfo ("",hbmp,size);


	
	
	Dlg.DoModal ();
}

BOOL CDlgBitmapListe::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	Liste.SetBmpSize (100,100);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgBitmapListe::OnContextMenu(CWnd*, CPoint point)
{

	// CG: This block was added by the Pop-up Menu component
	{
		if (point.x == -1 && point.y == -1){
			//keystroke invocation
			CRect rect;
			GetClientRect(rect);
			ClientToScreen(rect);

			point = rect.TopLeft();
			point.Offset(5, 5);
		}

		CMenu menu;
		VERIFY(menu.LoadMenu(CG_IDR_POPUP_DLG_BITMAP_LISTE));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;

		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
}

// Renvoie l'index du bitmap slectionn
int CDlgBitmapListe::GetSelectedBitmap()
{
	DWORD index;
	index = Liste.GetCurSel ();
	if (index == LB_ERR) return -1;
	return index;
}

int CDlgBitmapListe :: GetBitmapCount ()
{
	return Liste.GetCount ();
}



// Supprime un bitmap de la liste
int CDlgBitmapListe::DeleteSelectedTexture()
{
	DWORD index;
	index = Liste.GetCurSel ();
	if (index == LB_ERR) return -1;
	Liste.DeleteString (index);
	return index;
}

// Prend le handle du bitmap
HBITMAP CDlgBitmapListe :: GetTextureHandle (int index)
{
	return Liste.GetHbitmap (index);
}

