// DlgInfoTriangle.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "DlgInfoTriangle.h"
#include "math.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgInfoTriangle dialog
extern float PIMULMISSILAUTO;

CDlgInfoTriangle::CDlgInfoTriangle(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgInfoTriangle::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgInfoTriangle)
	PX1 = 0.0f;
	PX2 = 0.0f;
	PX3 = 0.0f;
	PY1 = 0.0f;
	PY2 = 0.0f;
	PY3 = 0.0f;
	PZ1 = 0.0f;
	PZ2 = 0.0f;
	PZ3 = 0.0f;
	AngX = 0.0f;
	AngZ = 0.0f;
	IndexFacette = 0;
	AngZCalc = 0.0f;
	AngXCalc = 0.0f;
	AdjX = 0.0f;
	AdjZ = 0.0f;
	OppX = 0.0f;
	OppZ = 0.0f;
	//}}AFX_DATA_INIT

	pFacette = NULL;
	pDoc = NULL;
}


void CDlgInfoTriangle::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgInfoTriangle)
	DDX_Text(pDX, IDC_EDIT_PX1, PX1);
	DDX_Text(pDX, IDC_EDIT_PX2, PX2);
	DDX_Text(pDX, IDC_EDIT_PX3, PX3);
	DDX_Text(pDX, IDC_EDIT_PY1, PY1);
	DDX_Text(pDX, IDC_EDIT_PY2, PY2);
	DDX_Text(pDX, IDC_EDIT_PY3, PY3);
	DDX_Text(pDX, IDC_EDIT_PZ1, PZ1);
	DDX_Text(pDX, IDC_EDIT_PZ2, PZ2);
	DDX_Text(pDX, IDC_EDIT_PZ3, PZ3);
	DDX_Text(pDX, IDC_EDIT_ANLGE_X, AngX);
	DDX_Text(pDX, IDC_EDIT_ANLGE_Z, AngZ);
	DDX_Text(pDX, IDC_EDITNO, IndexFacette);
	DDX_Text(pDX, IDC_EDIT_ANLGE_Z_CALC, AngZCalc);
	DDX_Text(pDX, IDC_EDIT_ANLGE_X_CALC, AngXCalc);
	DDX_Text(pDX, IDC_EDIT_ADJX, AdjX);
	DDX_Text(pDX, IDC_EDIT_ADJZ, AdjZ);
	DDX_Text(pDX, IDC_EDIT_OPPX, OppX);
	DDX_Text(pDX, IDC_EDIT_OPPZ, OppZ);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgInfoTriangle, CDialog)
	//{{AFX_MSG_MAP(CDlgInfoTriangle)
	ON_BN_CLICKED(IDC_CALCUL, OnCalcul)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgInfoTriangle message handlers

void CDlgInfoTriangle::SetPoint (int no,float x,float y,float z)
{
	switch (no)
	{
		case 1:
			PX1 = x;
			PY1 = y;
			PZ1 = z;
		break;

		case 2:
			PX2 = x;
			PY2 = y;
			PZ2 = z;
		break;

		case 3:
			PX3 = x;
			PY3 = y;
			PZ3 = z;
		break;
	}
}


BOOL CDlgInfoTriangle::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CDlgInfoTriangle :: CalculAngle ()
{
	POINTASC_TERRE * pa;
	POINTASC_TERRE * pb;
	POINTASC_TERRE * pc;
	float adj,opp;


	AngXCalc = 0;
	AngZCalc = 0;
	UpdateData (FALSE);

	pa = pDoc->GetPoint (pFacette->a.i,pFacette->a.j);
	pb = pDoc->GetPoint (pFacette->b.i,pFacette->b.j);
	pc = pDoc->GetPoint (pFacette->c.i,pFacette->c.j);

	adj = pc->x - pa->x;
	opp = pc->y - pa->y;
	AdjZ = adj;
	OppZ = opp;
	if (!adj) adj = 1;
	AngZCalc = (atan2 (opp,adj) * PIMULMISSILAUTO);

	adj = pb->z - pc->z;
	opp = pb->y - pc->y;
	AdjX = adj;
	OppX = opp;
	if (!adj) adj = 1;
	AngXCalc = (atan2 (opp,adj) * PIMULMISSILAUTO);


	if (IndexFacette%2)
	{
		AngZCalc += 180;
		AngXCalc += 180;
	}

	UpdateData (FALSE);


}

void CDlgInfoTriangle::OnCalcul() 
{
	// TODO: Add your control notification handler code here
	CalculAngle ();
}
