// DlggSetNbPolygone.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "DlggSetNbPolygone.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlggSetNbPolygone dialog


CDlggSetNbPolygone::CDlggSetNbPolygone(CWnd* pParent /*=NULL*/)
	: CDialog(CDlggSetNbPolygone::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlggSetNbPolygone)
	Nchunk = 0;
	//}}AFX_DATA_INIT
	Npoint = 0;
	Nchunk = 0;

}


void CDlggSetNbPolygone :: SetInfo (int NpointInit,int NchunkInit)
{
	Npoint = NpointInit;
	Nchunk = NchunkInit;
}

void CDlggSetNbPolygone::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlggSetNbPolygone)
	DDX_Control(pDX, IDC_SLIDER1, Slider);
	DDX_Text(pDX, IDC_EDIT_NCHUNK, Nchunk);
	DDV_MinMaxUInt(pDX, Nchunk, 0, 1000000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlggSetNbPolygone, CDialog)
	//{{AFX_MSG_MAP(CDlggSetNbPolygone)
	ON_EN_CHANGE(IDC_EDIT_NCHUNK, OnChangeEditNchunk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlggSetNbPolygone message handlers


BOOL CDlggSetNbPolygone::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	Slider.SetRange (0,Npoint);
	Slider.SetPos (Nchunk);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CDlggSetNbPolygone::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class
	Nchunk = Slider.GetPos ();
	UpdateData (FALSE);
	return CDialog::OnNotify(wParam, lParam, pResult);
}

void CDlggSetNbPolygone::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData (TRUE);
	if (Nchunk < 1) Nchunk = 1;
	CDialog::OnOK();
}

void CDlggSetNbPolygone::OnChangeEditNchunk() 
{
	UpdateData (TRUE);
	Slider.SetPos (Nchunk);
}
